#ifndef FILTER_H
#define FILTER_H

#include <vector>
#include <cmath>
#include "image.h"
#include "misc.h"
#include "convolve.h"
#include "imconv.h"

#define WIDTH 4.0

/* simple filters */
void normalize(std::vector<float> &mask);
image<float> *smooth(image<float> *src, float sigma);
image<float> *smooth(image<unsigned char> *src, float sigma);
image<float> *laplacian(image<float> *src);

#endif
