//Header file for the declaration of GPU (=CUDA) Powered
//rotating and tilting function by Martin Treiber, 26.03.2012

#ifndef __GPU_ROTATION_H__
#define __GPU_ROTATION_H__
#include <cuda.h>
#include <cuda_runtime.h>
#define _USE_MATH_DEFINES
#include <math.h>

CUdeviceptr copyImageToDevice(int width, int height, unsigned char* image);
void copyDeviceToImage(int width, int height, unsigned char* dest, CUdeviceptr source);
CUdeviceptr rotateAndTilt(int width, int height,int targetwidth,int targetheight, float angle, float tilt, CUdeviceptr source);
void freeMems(unsigned char* d_ptr);

#endif /*__GPU_ROTATION_H*/