#ifndef OPENCVUTIL_H
#define OPENCVUTIL_H

#include <QObject>

#include <opencv/cv.h>
#include <opencv/cv.hpp>

class testCimg2Mat : public QObject {
	Q_OBJECT
private:
	int width;
	int height;
	cv::Mat mat1;

private slots:
	void init();
	void testCImgFloat();
	void testCImgDouble();
	void testCImgUChar();
	void testCImgChar();
	void testCImgUShort();
	void testCImgShort();
};

class testMat2CImg : public QObject {
	Q_OBJECT
private:
	int width;
	int height;

private slots:
	void init();
	void test32FtoFloat();
	void test32FtoDouble();
	void test64FtoFloat();
	void test64FtoDouble();
	void test64FtoChar();
	void testCasting64FtoChar();
	void testCasting64FtoUChar();
	void test8UtoUchar();
	void test8UtoFloat();
};

#endif // OPENCVUTIL_H
