#ifndef _TENSOR_
#define _TENSOR_

//ijklƥ󥽥륯饹
class Tensor3333
{
  int in, jn, kn, ln;       //줾ǿ
  double**** t;             //

public:
  //1st constructor
  Tensor3333(int i = 3, int j = 3, int k = 3, int l = 3);

  //copy constructor
  Tensor3333(const Tensor3333&);

  //destructor
  ~Tensor3333();

  //ǼФ
  double&       operator()(int, int, int, int);
  const double& operator()(int, int, int, int) const;


  //黻  
  const Tensor3333& operator=(const Tensor3333&);

  //ѱ黻
  Tensor3333 operator+(const Tensor3333&) const;  //­
  Tensor3333 operator-(const Tensor3333&) const;  //
  Tensor3333 operator*(double) const;             //
  friend Tensor3333 operator*(double, const Tensor3333&);
  //3333ƥ󥽥*33
  Matrix operator*(const Matrix&);
  Tensor3333 operator/(double);  //任  
  //洹
  friend Tensor3333 operator-(const Tensor3333&);

  //줾μ
  int DimI() const { return in; }
  int DimJ() const { return jn; }
  int DimK() const { return kn; }
  int DimL() const { return ln; }

  //
  int Init();

  //ʣˤ3333ƥ󥽥
  void Fill();

  //ʣˤ(33)(33)ƥ󥽥
  void FillSym();

  //(33)(33)ƥ󥽥ƤθͭͤƤθͭ
  int EigenSym(VectorN&, Matrix*);

  //3333ƥ󥽥ƤθͭͤƤθͭ
  int Eigen(VectorN&, Matrix*);
                                                 
  //(33)(33)ƥ󥽥ΰ̵դ
  friend Tensor3333 GeneralInverseSym(const Tensor3333&, int times = 0);

  //3333ƥ󥽥ΰ̵դ
  friend Tensor3333 GeneralInverse(const Tensor3333&, int times = 0);
  
  //ǽ
  void Print();
  void Fprint(FILE*);
};

  //ƥ󥽥(ΣĤιϣߣ˸¤)
  Tensor3333 TensorProduct(const Matrix&, const Matrix&);

#endif //_TENSOR_
